#pragma semicolon 1

#include <sourcemod>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP [Team]",
	author	= "wS",
	version = "1.2.3"
};

#define ITEM_NAME "team"
new g_bAccess[MAXPLAYERS + 1];

public OnPluginStart()
{
	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_SELECT)) SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);
	AddCommandListener(jointeam, "jointeam");
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_bAccess[client])
	{
		IntToString(1, ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	if (g_bAccess[client]) return VGA_AlreadyEnabled;
	SetStatus(client, true);
	return VGA_Continue;
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	SetStatus(client, false);
}

stock SetStatus(client, bool:enabled)
{
	g_bAccess[client] = enabled;
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, enabled);
}

///////////////////////////////////////////////////////////////////////////////////

public OnClientDisconnect(client) g_bAccess[client] = false;
public VIP_MenuSelect(client, ItemID) ShowMenu(client);

stock ShowMenu(client)
{
	new Handle:menu = CreateMenu(Menu_CallBack);
	SetMenuExitBackButton(menu,		true);
	SetMenuTitle(menu, "Team:\n \n");
	AddMenuItem (menu, "2", "T",	ITEMDRAW_DEFAULT);
	AddMenuItem (menu, "3", "CT",	ITEMDRAW_DEFAULT);
	AddMenuItem (menu, "1", "SPEC",	ITEMDRAW_DEFAULT);
	DisplayMenu (menu, client, 0);
}

public Menu_CallBack(Handle:menu, MenuAction:action, client, item)
{
	if (action == MenuAction_End) {
		CloseHandle(menu);
	}
	else if (action == MenuAction_Select && !VIP_MenuFlood(client))
	{
		if (!VIP_HaveAccessToItem(client, VIP_GetItemID(ITEM_NAME)))
		{
			VIP_ShowMenu(client);
			return;
		}
		decl String:info[8];
		if (GetMenuItem(menu, item, info, sizeof(info))) {
			ChangeClientTeam(client, StringToInt(info));
		}
		ShowMenu(client);
	}
	else if (action == MenuAction_Cancel && item == MenuCancel_ExitBack && !VIP_MenuFlood(client)) {
		VIP_ShowMenu(client);
	}
}

public Action:jointeam(client, const String:command[], args)
{
	if (client > 0 && client <= MaxClients && g_bAccess[client])
	{
		decl String:s[8];
		GetCmdArg(1, s, sizeof(s));
		new team = StringToInt(s);
		if (team > 0 && team < 4)
		{
			ChangeClientTeam(client, team);
			return Plugin_Handled;
		}
	}
	return Plugin_Continue;
}